
%function to calculate the unique pair
%type r , c to get corresponding rc pairs
%written by Dr Siddhartha Sarma and Ankita Nandi (4/6/17)
function [r,c]=unique_pair(Vec,pop)
global Th;
A=Vec;
diff =zeros(pop,pop);%initializing difference matrix
diff=abs(bsxfun(@minus, A, A'));%taking all possible element combinations and finding difference
diff=double(diff<Th);
diff=tril(diff,-1);%taking the lower triangular matrix
r=[];%initialize empty row
c=[];%initialize empty column
colSumOfDiff = sum(diff); %column sum of A
nzColSet =find(colSumOfDiff); %find the columns that has atleast one potential pair
i=1; %variable to traverse the entries of nzColSet
while i<length(nzColSet)
    nzRowsIndcs = find(diff(:,nzColSet(i))); %find the indices of rows that has non zero values, i.e.,
    nzRowsIndcs = setdiff(nzRowsIndcs,r);
    if ~isempty(nzRowsIndcs)
        rndSelectRow=nzRowsIndcs(randi(length(nzRowsIndcs)),1); %randomly select a row index
        r=[r rndSelectRow]; %include the row index of the pair
        c=[c nzColSet(i)];   %include the column index of the pair
        nzColSet(nzColSet==rndSelectRow)=[]; %remove the index that has been included
    end
    i=i+1;
end

